% einlesen aller daten
daten_read_b;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% building up of y und Z, Z containing first the group-specific and then the fixed effects

lag_y=max(lag_dir,lag_dlo);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% selection of the cross-section unit

index=[1:nbank];iout=(index~=index);

% oultier handling: iout(i)==1 exclude time series i

%outmerge=1;  %exclude time series containing mergers
outmerge=0;
if outmerge==1; iout=any(dlo_out==1); end   

miss=1; %treat mergers as missing values
%miss=0;
if miss==1
    dlo_obs=dlo; % actual observations; 
    dlo_m=median(dlo);
    for i=index
        if  any(dlo_out(:,i)) 
            dlo(dlo_out(:,i)==1,i) = dlo_m(i);
            %substitute median as starting value for missing observations at mergers
        end   
    end   
end   

dlo_max=max(dlo);dlo_min=min(dlo);
outy=0;
%outy=1;scale=5;%exclude time series with outliers
if outy==1; dlo_m=median(dlo);dlo_s=iqr(dlo);iout=or(dlo_max>dlo_m+scale/1.34*dlo_s,dlo_min<dlo_m-scale/1.34*dlo_s) ;%'max > scale*(iqr/1.34)'
end

liq_sh=0; %flag (1) to eliminate banks with liquidity shares above 100% 
exclude_ind; 
iout(1,ind)=1;

plot_out=0;
if plot_out==1
    iplot=0;ifig=20;nplot=12;nline=3;xmin=-50;xmax=100;
    for i=index(iout)
        iplot=iplot+1;
        if iplot==1;ifig=ifig+1;figure(ifig);end
        subplot(nplot/nline,nline,iplot);
        plot(dlo(:,i));
        %  axis([0 nobs+2  xmin xmax]);
        alpha=0.3;
        axis([0 nobs+2  dlo_min(i)/(1-alpha) dlo_max(i)*(1+alpha)]);
        legend(num2str(BLZ(i)));
        if iplot==nplot;iplot=0;end
    end   
end


indexb=index(~iout);%selection of the units 
indexn=[(1+lag_y):nobs]';%take into account autocorrelation

y=dlo(indexn,indexb);
% cal=cal(indexn);

Z_dlolag=[];
if lag_dlo>0
    for i1=1:lag_dlo
        Z_add(1:size(indexn,1),1,1:size(indexb,2))=dlo(indexn-i1,indexb);
        Z_dlolag=cat(2,Z_dlolag,Z_add);
    end;clear i1
end   

Zvar=[];

for iv=[1 ]; % 1 .. lagged interest rate changes
    %Zvar=cat(2,Zvar,Zbasis(indexn,iv,indexb));
    if lag_dir>0
        for i1=1:lag_dir
            Z_add(1:size(indexn,1),1,1:size(indexb,2))=Zbasis(indexn-i1,iv,indexb);
            Zvar=cat(2,Zvar,Z_add);
        end;clear i1
    end 
end; clear iv;

Z=cat(2,Zvar,Z_dlolag,Zwirt(indexn,:,indexb),Zdum(indexn,[1:3],indexb),c(indexn,:,indexb));
if lag_dlo>0
    ill=size(Zvar,2);
    isp_lag_dlo=[ill+1:ill+lag_dlo];  
    %indicates the columns of Z in which the lagged endogenous values of y are stored
else
    ill=size(Zvar,2);
    isp_lag_dlo=[];
end

ZMS=Z(:,[1:ill],:);
if not_switch
    ZMS=[]; 
end

% ZMS contains the columns of Z which have switching effects over time

if length(index0)>0;
    IMS=probMS;
else
    IMS=(squeeze(Zwirt(end-size(y)+1:end,2,1))>0)';
    if not_switch
        IMS=IMS*0+1; 
    end
end
%starting value for MS-indicator: IMS(t+1) = 1, if delta(BIP)_t>0, 0 otheriwse

%defining S
S=zeros(1,length(indexb));
if gr_fix
    group_fix
    S=gr_ind;
%     S=ones(1,length(indexb));
end


clear lenddata_b Zbasis Zdum Zdumli Zwirt Zvar Zvarli Z_dlolag Z_add  c;
cwd = pwd;
cd(tempdir);
pack
cd(cwd)

